
#include "CrypFile.h"

#include <mbctype.h>

#include "RedirectingPath.h"
#include "RedirectingPathW.h"

/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/

//namespace AY_LIB{
////////////////////////////////////////////////////////////////////////////////
//#	RXgN^
/// @brief	RXgN^
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile::CCrypFile():m_dwAccess(0),m_bCryp(FALSE),m_dwPos(0),m_hFile(NULL),
	m_dwFileSize(0),m_BlowFishFlag(FALSE),m_pistream(NULL),m_postream(NULL),m_stream(NULL),
	m_pRedirectingPath(NULL)
{
	m_buf.clear();
}

////////////////////////////////////////////////////////////////////////////////
//#	RXgN^
/// @brief	RXgN^
/// @param[in]	pFileName	I[vt@C
/// @param[in]	dwAccess	ANZX[h
/// @param[in]	bCryp		ÍtO
/// @param[in]	key			ÍL[
/// @param[in]	keybytes	ÍL[̃oCg
/// @note	wt@Cw胂[hŊJ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
/*
CCrypFile::CCrypFile(const _TCHAR* pFileName, DWORD dwAccess, 
					BOOL bCryp, BYTE *key, int keybytes):
					m_dwAccess(0),m_bCryp(FALSE),m_dwPos(0),m_hFile(NULL),
						m_dwFileSize(0),m_BlowFishFlag(FALSE),m_pistream(NULL),m_postream(NULL),
						m_stream(NULL)
{
	m_buf.clear();
	CCrypFile::Open(pFileName, dwAccess, bCryp, key, keybytes);
}
*/
////////////////////////////////////////////////////////////////////////////////
//#	RXgN^
/// @brief	RXgN^
/// @param[in]	pFileName	I[vt@C
/// @param[in]	dwAccess	ANZX[h
/// @param[in]	bCryp		ÍtO
/// @param[in]	key			ÍL[
/// @note	wt@Cw胂[hŊJ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile::CCrypFile(const _TCHAR* pFileName, DWORD dwAccess, BOOL bCryp, const _TCHAR* key):
					m_dwAccess(0),m_bCryp(FALSE),m_dwPos(0),m_hFile(NULL),
						m_dwFileSize(0),m_BlowFishFlag(FALSE),m_pistream(NULL),m_postream(NULL),
						m_stream(NULL),m_pRedirectingPath(NULL)
{
	m_buf.clear();
	CCrypFile::Open(pFileName, dwAccess, bCryp, key);
}

////////////////////////////////////////////////////////////////////////////////
//#	fXgN^
/// @brief	fXgN^
/// @note	o[hŃt@CJĂꍇ̓fXgN^ŏo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile::~CCrypFile()
{
	Close();
}

////////////////////////////////////////////////////////////////////////////////
//#	ÍL[̃Zbg
/// @brief	ÍL[̃Zbg
/// @param[in]	key			ÍL[
/// @param[in]	keybytes	ÍL[̃oCg
/// @note	CBlowFishɈÍL[Zbg
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
//ÍL[Zbg
void CCrypFile::Initialize(BYTE *key, int keybytes)
{
	m_BlowFish.Initialize(key, keybytes);
	m_BlowFishFlag = TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	Í
/// @brief	Í
/// @param[in,out]	buf	ÍoCg
/// @retval	TRUE:	FALSE:s
/// @note	woCgÍ
/// @attention	łɈÍĂoCgnĂ͂Ȃ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::CrypEnc(std::vector<BYTE> &buf)
{
	if(!m_BlowFishFlag)
	{//ÍNX̏IĂȂ
		return FALSE;
	}
	if(buf.empty())
	{//f[^Ȃ
		return FALSE;
	}
	DWORD dwOutSize = m_BlowFish.GetOutputLength(buf.size());
	std::vector<BYTE> OutBuf;
	OutBuf.resize(dwOutSize + HeaderSize + (sizeof(DWORD)));
	ZeroMemory(&OutBuf[0], OutBuf.size());
	//wb_
	memcpy(&OutBuf[0], CrypHeader, HeaderSize);
	//t@CTCY
	*(DWORD*)&OutBuf[HeaderSize] = m_buf.size();

	m_BlowFish.Encode(&buf[0],&OutBuf[HeaderSize+(sizeof(DWORD))],dwOutSize);
	buf.swap(OutBuf);
//	std::swap(buf, OutBuf);
//	std::copy(OutBuf.begin(), OutBuf.begin() + buf.size(), buf.begin());
	OutBuf.clear();
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	
/// @brief	
/// @param[in,out]	buf	oCg
/// @retval	TRUE:	FALSE:s
/// @note	ÍĂoCg𕜌
/// @attention	ÍĂȂoCgnĂs
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::CrypDec(std::vector<BYTE> &buf)
{
	if(!m_BlowFishFlag)
	{//ÍNX̏IĂȂ
		return FALSE;
	}
	if(buf.empty())
	{//f[^Ȃ
		return FALSE;
	}
	if(memcmp(&buf[0], CrypHeader, HeaderSize) != 0)
	{//wb_Ⴄ
		return TRUE;
//		return FALSE;
	}
	DWORD dwDataSize = *(DWORD *)&buf[HeaderSize];
	DWORD dwOutSize = m_BlowFish.GetOutputLength(buf.size() - (HeaderSize + sizeof(DWORD)));

	//t@CTCY
	if(dwOutSize < dwDataSize || (dwOutSize < 8 ? 0 : dwOutSize - 8) > dwDataSize)
	{//t@CTCYs
		return FALSE;
	}

	std::vector<BYTE> OutBuf;
	OutBuf.resize(dwOutSize);
	ZeroMemory(&OutBuf[0], OutBuf.size());
	m_BlowFish.Decode(&buf[HeaderSize + sizeof(DWORD)],&OutBuf[0],dwOutSize);
//	buf.swap(OutBuf);
	buf.clear();
	buf.resize(dwDataSize);
	std::copy(OutBuf.begin(), OutBuf.begin() + dwDataSize, buf.begin());
	OutBuf.clear();
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@Cǂݍ݃[hŊJ
/// @brief	t@Cǂݍ݃[hŊJ
/// @param[in]	pFileName	Jt@C
/// @param[in]	bCryp		ÍĂt@CH
/// @retval	TRUE:	FALSE:s
/// @note	wt@CJAɕێB̂ƂbCrypTRUEȂAfR[hs
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::LoadOpen(const _TCHAR* pFileName, BOOL bCryp)
{
	if(!m_pRedirectingPath)
	{
		m_pRedirectingPath = new CRedirectingPath();
	}
	std::string str;
	str = m_pRedirectingPath->GetReadFilePath(pFileName);

	//t@CJ
	m_hFile = ::CreateFileA(str.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	if(m_hFile == INVALID_HANDLE_VALUE)
	{//I[vG[
		m_hFile = NULL;
		return FALSE;
	}
	//擪ɃZbgĂ
	::SetFilePointer(m_hFile, 0, NULL, FILE_BEGIN);

	//t@C̃TCY擾
	m_dwFileSize = ::GetFileSize(m_hFile, NULL);

	//f[^擾
	m_buf.resize(m_dwFileSize);
	DWORD dwRead = ReadFile(&m_buf[0], m_dwFileSize);
	if(dwRead != m_dwFileSize)
	{//ǂݍݎs
		Close();
		return FALSE;
	}

	if(bCryp)
	{//Í...?
		CrypDec(m_buf);
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@Cǂݍ݃[hŊJ
/// @brief	t@Cǂݍ݃[hŊJ
/// @param[in]	pFileName	Jt@C
/// @param[in]	bCryp		ÍĂt@CH
/// @retval	TRUE:	FALSE:s
/// @note	wt@CJAɕێB̂ƂbCrypTRUEȂAfR[hs
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::LoadOpen(const PCWSTR pFileName, BOOL bCryp)
{
	if(!m_pRedirectingPath)
	{
		m_pRedirectingPath = new CRedirectingPathW();
	}
	std::wstring str;
	str = m_pRedirectingPath->GetReadFilePath(pFileName);

	//t@CJ
	m_hFile = ::CreateFileW(str.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	if(m_hFile == INVALID_HANDLE_VALUE)
	{//I[vG[
		m_hFile = NULL;
		return FALSE;
	}
	//擪ɃZbgĂ
	::SetFilePointer(m_hFile, 0, NULL, FILE_BEGIN);

	//t@C̃TCY擾
	m_dwFileSize = ::GetFileSize(m_hFile, NULL);

	//f[^擾
	m_buf.resize(m_dwFileSize);
	DWORD dwRead = ReadFile(&m_buf[0], m_dwFileSize);
	if(dwRead != m_dwFileSize)
	{//ǂݍݎs
		Close();
		return FALSE;
	}

	if(bCryp)
	{//Í...?
		CrypDec(m_buf);
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@C݃[hŊJ
/// @brief	t@C݃[hŊJ
/// @param[in]	pFileName	Jt@C
/// @param[in]	bCryp		ÍtOigpj
/// @retval	TRUE:	FALSE:s
/// @note	t@Co[hŊJB
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::SaveOpen(const _TCHAR* pFileName, BOOL bCryp)
{
	if(!m_pRedirectingPath)
	{
		m_pRedirectingPath = new CRedirectingPath();
	}
	std::string str;
	str = m_pRedirectingPath->GetWriteFilePath(pFileName);

	//t@CJ
	m_hFile = ::CreateFileA(str.c_str(), GENERIC_WRITE, 0, NULL, 
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	//t@CJȂ
	if(m_hFile == INVALID_HANDLE_VALUE){
		m_hFile = NULL;
		return FALSE;
	}
	SetPos(0, 0, FILE_BEGIN);
	
	//t@C̃TCY擾
	m_dwFileSize = ::GetFileSize(m_hFile, NULL);
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@C݃[hŊJ
/// @brief	t@C݃[hŊJ
/// @param[in]	pFileName	Jt@C
/// @param[in]	bCryp		ÍtOigpj
/// @retval	TRUE:	FALSE:s
/// @note	t@Co[hŊJB
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::SaveOpen(const PCWSTR pFileName, BOOL bCryp)
{
	if(!m_pRedirectingPath)
	{
		m_pRedirectingPath = new CRedirectingPathW();
	}
	std::wstring str;
	str = m_pRedirectingPath->GetWriteFilePath(pFileName);

	//t@CJ
	m_hFile = ::CreateFileW(str.c_str(), GENERIC_WRITE, 0, NULL, 
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	//t@CJȂ
	if(m_hFile == INVALID_HANDLE_VALUE){
		m_hFile = NULL;
		return FALSE;
	}
	SetPos(0, 0, FILE_BEGIN);
	
	//t@C̃TCY擾
	m_dwFileSize = ::GetFileSize(m_hFile, NULL);
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@Cǂݏp[hŊJ
/// @brief	t@Cǂݏp[hŊJ
/// @param[in]	pFileName	Jt@C
/// @param[in]	bCryp		ÍtO
/// @retval	TRUE:	FALSE:s
/// @note	ݖ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::CombinationOpen(const _TCHAR* pFileName, BOOL bCryp)
{
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@CwTCYf[^ǂݍ
/// @brief	t@CwTCYf[^ǂݍ
/// @param[out]	lpBuf	f[^󂯎|C^
/// @param[in]	size	ǂݍރoCg
/// @retval	0:ǂݍݎs	ǂݍ񂾃oCg
/// @note	t@Cw̃|C^Ƀf[^ǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
DWORD CCrypFile::ReadFile(LPVOID lpBuf, DWORD size)
{
	if(m_hFile == NULL)
	{
		return 0;
	}

	DWORD dwRead;
	if(::ReadFile(m_hFile, lpBuf, size, &dwRead, NULL) == 0)
	{
		//ǂݍݎs
		return 0;
	}
	return dwRead;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@C֎wTCYf[^o
/// @brief	t@C֎wTCYf[^o
/// @param[in]	lpBuf	of[^ւ̃|C^
/// @param[in]	size	of[^TCY
/// @retval	0:os	ooCg
/// @note	wf[^t@Cɏo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
DWORD CCrypFile::WriteFile(LPVOID lpBuf, DWORD size)
{
	if(m_hFile == NULL)
	{
		return 0;
	}

	DWORD dwWrite;
	if(::WriteFile(m_hFile, lpBuf, size, &dwWrite, NULL) == 0)
	{
		//ݎs
		return 0;
	}
	return dwWrite;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@C|C^ړ
/// @brief	t@C|C^ړ
/// @param[in]	Move		t@C|C^ړoCgw肷
/// @param[in]	MoveHigh	64rbg̈ړ̏ʃ[hw|C^
/// @param[in]	MoveMethod	t@C |C^̈ړ̎n_w肷\n
///							FILE_BEGIN:t@C̐擪\n
///							FILE_CURRENT:݂̈ʒu\n
///							FILE_END:t@C̖
/// @retval	Vt@C |C^̉ʃ_u[h
/// @note	API SetFilePointerĂяo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
DWORD CCrypFile::SetPos(LONG Move, LONG *MoveHigh, DWORD MoveMethod)
{
	if(!m_hFile) return 0;
	return ::SetFilePointer(m_hFile, Move, MoveHigh, MoveMethod);
}

////////////////////////////////////////////////////////////////////////////////
//#	Xg[쐬
/// @brief	Xg[쐬
/// @param[in]	dwAccess	ANZX[h
/// @retval	TRUE:	FALSE:s
/// @note	ANZX[hɑΉXg[ɕێĂobt@Zbg
/// @attention	
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::CreateStream(DWORD dwAccess)
{
	if(!(dwAccess & CRYP_TEXT_OPEN))
	{//eLXg[hł͂Ȃ
		return FALSE;
	}
	if(m_stream)
	{
		delete m_stream;
		m_stream = NULL;
	}
	if(m_pistream)
	{
		delete m_pistream;
		m_pistream = NULL;
	}
	if(m_postream)
	{
		delete m_postream;
		m_postream = NULL;
	}
	if(dwAccess & CRYP_LOAD_OPEN)
	{
		if(m_buf.empty())
		{//f[^Ȃ
			return FALSE;
		}

		m_stream = new std::stringstream();
		//stringstreamɃf[^Zbg
		m_buf.push_back((BYTE)'\0');

		//sR[h'\n'݂̂ɕϊ
		CodeUnionConversion(m_buf);

		*m_stream << (char *)&m_buf[0];
		m_buf.clear();
		//istreamstringstreamZbg
		m_pistream = new std::istream(*m_stream);
		return TRUE;
	}
	else if(dwAccess & CRYP_SAVE_OPEN)
	{
		m_stream = new std::stringstream();
		m_postream = new std::ostream(*m_stream);
		return TRUE;
	}
	//I[v[hwG[
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
//#	Xg[f[^擾
/// @brief	Xg[f[^擾
/// @param[in]	dwAccess	ANZX[h
/// @retval	TRUE:	FALSE:s
/// @note	Xg[obt@Ƀf[^ړ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::GetStream(DWORD dwAccess)
{
	if(!(dwAccess & CRYP_TEXT_OPEN))
	{//eLXg[hł͂Ȃ
		return FALSE;
	}
	if(!m_stream || m_stream->str().empty())
	{//f[^Ȃ
		return FALSE;
	}
	//f[^̃Rs[
	DWORD size = m_stream->str().size();
	m_buf.resize(size);
	memcpy(&m_buf[0], m_stream->str().c_str(), size);
	//I[ǉĂ
	m_buf.push_back((BYTE)'\0');

	//sR[hWindowspɕϊ...
	CodeUnionReturn(m_buf);

	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@CJ
/// @brief	t@CJ
/// @param[in]	pFileName	Jt@C
/// @param[in]	dwAccess	ANZX[h
/// @param[in]	bCryp		ÍtO
/// @param[in]	key			ÍL[
/// @retval	TRUE:	FALSE:s
/// @note	w胂[hŃt@CJ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::Open(const _TCHAR* pFileName, DWORD dwAccess, BOOL bCryp, const _TCHAR* key)
{
	Close();

	m_dwPos		= 0;
	m_dwAccess	= dwAccess;
	m_bCryp		= bCryp;
	m_buf.clear();

	//ÍNX
	if(bCryp && key)
	{
		Initialize((BYTE *)key, _tcslen(key) * sizeof(_TCHAR));
	}

	BOOL ret = FALSE;
	if(dwAccess & CRYP_LOAD_OPEN)
	{//ǂݍ
		ret = LoadOpen(pFileName, bCryp);
		CreateStream(m_dwAccess);
	}
	else if(dwAccess & CRYP_SAVE_OPEN)
	{//o
		ret = SaveOpen(pFileName, bCryp);
		CreateStream(m_dwAccess);
	}
//	else if(dwAccess & CRYP_COMBINATION_OPEN)
//	{//p
//		return CombinationOpen(pFileName, bCryp);
//	}
	return ret;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@CJ
/// @brief	t@CJ
/// @param[in]	pFileName	Jt@C
/// @param[in]	dwAccess	ANZX[h
/// @param[in]	bCryp		ÍtO
/// @param[in]	key			ÍL[
/// @retval	TRUE:	FALSE:s
/// @note	w胂[hŃt@CJ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::Open(const PCWSTR pFileName, DWORD dwAccess, BOOL bCryp, const _TCHAR* key)
{
	Close();

	m_dwPos		= 0;
	m_dwAccess	= dwAccess;
	m_bCryp		= bCryp;
	m_buf.clear();

	//ÍNX
	if(bCryp && key)
	{
		Initialize((BYTE *)key, _tcslen(key) * sizeof(_TCHAR));
	}

	BOOL ret = FALSE;
	if(dwAccess & CRYP_LOAD_OPEN)
	{//ǂݍ
		ret = LoadOpen(pFileName, bCryp);
		CreateStream(m_dwAccess);
	}
	else if(dwAccess & CRYP_SAVE_OPEN)
	{//o
		ret = SaveOpen(pFileName, bCryp);
		CreateStream(m_dwAccess);
	}
	return ret;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@C
/// @brief	t@C
/// @retval	TRUE:	FALSE:s
/// @note	o[hɂ̓t@CۑAJĂt@C
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::Close(void)
{
	//oŊJĂꍇ͕ۑ
	if(m_dwAccess & CRYP_SAVE_OPEN/* || m_dwAccess & CRYP_COMBINATION_OPEN*/)
	{
		if(m_stream)
		{
			GetStream(m_dwAccess);
		}
		if(!m_buf.empty())
		{
			if(m_bCryp)
			{
#ifndef	_DEBUG
				CrypEnc(m_buf);
#endif
			}
			WriteFile(&m_buf[0], m_buf.size());
		}
	}

	if(m_pistream)
	{
		delete m_pistream;
		m_pistream = NULL;
	}
	if(m_postream)
	{
		delete m_postream;
		m_postream = NULL;
	}
	if(m_stream)
	{
		delete m_stream;
		m_stream = NULL;
	}

	if(m_hFile)
	{
		::CloseHandle(m_hFile);
		m_hFile = NULL;
	}

	m_dwFileSize	= 0;
	m_dwPos			= 0;
	m_dwAccess		= 0;
	m_bCryp			= FALSE;
	m_buf.clear();

	//pX쐬NX̍폜
	if(m_pRedirectingPath)
	{
		m_pRedirectingPath->Delete();
		m_pRedirectingPath = NULL;
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	f[^̓ǂݍ
/// @brief	f[^̓ǂݍ
/// @param[out]	lpBuf	f[^󂯎|C^
/// @param[in]	size	f[^TCY
/// @retval	0:s	ǂݍ񂾃TCY
/// @note	ێĂf[^AwTCYf[^󂯎Af[^|C^ړ
/// @attention	oCiǂݍ݃[ĥݗL
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
DWORD CCrypFile::Read(LPVOID lpBuf, DWORD size)
{
	if(m_buf.empty())
	{//f[^
		return 0;
	}

	//Rs[TCY
	DWORD copysize = m_buf.size() - m_dwPos < size ? m_buf.size() - m_dwPos : size;
	if(copysize == 0)
	{//ǂݍ߂TCYȂ
		return 0;
	}
	//Rs[
	memcpy(lpBuf, &m_buf[m_dwPos], copysize);
	m_dwPos += copysize;
	return copysize;
}

////////////////////////////////////////////////////////////////////////////////
//#	f[^̒ǉ
/// @brief	f[^̒ǉ
/// @param[in]	lpBuf	ǉf[^
/// @param[out]	size	ǉTCY
/// @retval	ǉf[^TCY
/// @note	ێĂf[^̍ŌɎwf[^ǉ
/// @attention	oCi[ĥݗL
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
DWORD CCrypFile::Write(LPVOID lpBuf, DWORD size)
{
	if(m_stream)
	{//eLXg[h
		return 0;
	}
	//g
	m_buf.insert(m_buf.end(), (BYTE*)lpBuf, (BYTE*)lpBuf+size);
	return size;
}

////////////////////////////////////////////////////////////////////////////////
//#	gt@Cʒuړ
/// @brief	gt@Cʒuړ
/// @param[in]	Move	ړoCgTCY
/// @param[in]	MoveMethod	t@C |C^̈ړ̎n_w肷\n
///							FILE_BEGIN:t@C̐擪\n
///							FILE_CURRENT:݂̈ʒu\n
///							FILE_END:t@C̖
/// @retval	ړʒu
/// @note	f[^w|C^ړ
/// @attention	oCi[ĥݗL
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
DWORD CCrypFile::SetFilePointer(LONG Move, DWORD MoveMethod)
{
	if(m_stream)
	{//eLXg[h
		return 0xFFFFFFFF;
	}
	switch(MoveMethod)
	{
	case FILE_BEGIN:
		m_dwPos = m_buf.size() < Move ? m_buf.size() : Move;
		return m_dwPos;
		break;
	case FILE_CURRENT:
		m_dwPos = m_buf.size() < m_dwPos + Move ? m_buf.size() : m_dwPos + Move;
		return m_dwPos;
		break;
	case FILE_END:
		m_dwPos = m_buf.size() < m_buf.size() + Move ? m_buf.size() : m_buf.size() + Move;
		return m_dwPos;
		break;
	}
	return 0xFFFFFFFF;
}

////////////////////////////////////////////////////////////////////////////////
//#	ێĂf[^Íĕۑ
/// @brief	ێĂf[^Íĕۑ
/// @param[in]	pFileName	ot@C
/// @param[in]	key			ÍL[
/// @param[in]	keybytes	ÍL[̃TCY
/// @retval	TRUE:	FALSE:s
/// @note	ێĂf[^ÍL[ňÍAt@Cɕۑ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::SaveCrypEncFile(const _TCHAR *pFileName, BYTE *key, int keybytes)
{
	if(m_buf.empty())
	{//f[^
		return FALSE;
	}
	std::vector<BYTE> buf;
	buf=m_buf;

	if(key && keybytes > 0)
	{
		Initialize(key, keybytes);
	}

	if(!CrypEnc(buf))
	{//Ís
		return FALSE;
	}

	if(!m_pRedirectingPath)
	{
		m_pRedirectingPath = new CRedirectingPath();
	}
	std::string str;
	str = m_pRedirectingPath->GetWriteFilePath(pFileName);

	//t@CJ
	HANDLE hFile = ::CreateFileA(str.c_str(), GENERIC_WRITE, 0, NULL, 
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	//t@CJȂ
	if(hFile == INVALID_HANDLE_VALUE){
		return FALSE;
	}
	::SetFilePointer(hFile, 0, NULL, FILE_BEGIN);

	DWORD dwWrite;
	::WriteFile(hFile, &buf[0], buf.size(), &dwWrite, NULL);
	::CloseHandle(hFile);
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	ێĂf[^𕜌ĕۑ
/// @brief	ێĂf[^𕜌ĕۑ
/// @param[in]	pFileName	ۑt@C
/// @param[in]	key			ÍL[
/// @param[in]	keybytes	ÍL[TCY
/// @retval	TRUE:	FALSE:s
/// @note	ێĂf[^ÍL[ŕAt@Cɕۑ
/// @attention	ÍĂȂf[^Iɕs
/// @author	R
/// @date	2006/125/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::SaveCrypDecFile(const _TCHAR *pFileName, BYTE *key, int keybytes)
{
	if(m_buf.empty())
	{//f[^
		return FALSE;
	}
	std::vector<BYTE> buf;
	buf=m_buf;

	if(key && keybytes > 0)
	{
		Initialize(key, keybytes);
	}

	if(!CrypDec(buf))
	{//Ís
		return FALSE;
	}

	if(!m_pRedirectingPath)
	{
		m_pRedirectingPath = new CRedirectingPath();
	}
	std::string str;
	str = m_pRedirectingPath->GetWriteFilePath(pFileName);

	//t@CJ
	HANDLE hFile = ::CreateFileA(str.c_str(), GENERIC_WRITE, 0, NULL, 
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	//t@CJȂ
	if(hFile == INVALID_HANDLE_VALUE){
		return FALSE;
	}
	::SetFilePointer(hFile, 0, NULL, FILE_BEGIN);

	DWORD dwWrite;
	::WriteFile(hFile, &buf[0], buf.size(), &dwWrite, NULL);
	::CloseHandle(hFile);
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	ێĂf[^t@Cɕۑ
/// @brief	ێĂf[^t@Cɕۑ
/// @param[in]	pFileName	ۑt@C
/// @retval	TRUE:	FALSE:s
/// @note	ێĂf[^t@Cɏo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::SaveNoCrypFile(const _TCHAR *pFileName)
{
	if(m_buf.empty())
	{//f[^
		return FALSE;
	}

	if(!m_pRedirectingPath)
	{
		m_pRedirectingPath = new CRedirectingPath();
	}
	std::string str;
	str = m_pRedirectingPath->GetWriteFilePath(pFileName);

	//t@CJ
	HANDLE hFile = ::CreateFileA(str.c_str(), GENERIC_WRITE, 0, NULL, 
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	//t@CJȂ
	if(hFile == INVALID_HANDLE_VALUE){
		return FALSE;
	}
	::SetFilePointer(hFile, 0, NULL, FILE_BEGIN);

	DWORD dwWrite;
	::WriteFile(hFile, &m_buf[0], m_buf.size(), &dwWrite, NULL);
	::CloseHandle(hFile);
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	1o
/// @brief	1o
/// @param[in]	obj		oBYTE
/// @retval	Q
/// @note	ostreamɂPo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(unsigned char obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	1o
/// @brief	1o
/// @param[in]	obj		ochar
/// @retval	Q
/// @note	ostreamɂPo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(char obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	1o
/// @brief	1o
/// @param[in]	obj		osigned char
/// @retval	Q
/// @note	ostreamɂPo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(signed char obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}

////////////////////////////////////////////////////////////////////////////////
//#	񏑂o
/// @brief	񏑂o
/// @param[in]	obj		oւ̃|C^
/// @retval	Q
/// @note	ostreamɕo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(const char *obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	񏑂o
/// @brief	񏑂o
/// @param[in]	obj		oւ̃|C^
/// @retval	Q
/// @note	ostreamɕo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(const unsigned char *obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	񏑂o
/// @brief	񏑂o
/// @param[in]	obj		oւ̃|C^
/// @retval	Q
/// @note	ostreamɕo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(const signed char *obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(short obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(unsigned short obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(int obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(unsigned int obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(long obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(unsigned long obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(double obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(long double obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lo
/// @brief	lo
/// @param[in]	obj		ol
/// @retval	Q
/// @note	ostreamɐlo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(float obj)
{
	if(m_postream)
	{
		*m_postream << obj;
	}
	return *this;
}

////////////////////////////////////////////////////////////////////////////////
//#	std::stringo
/// @brief	std::stringo
/// @param[in]	obj		ostd::string
/// @retval	Q
/// @note	o
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(std::string obj)
{
	if(m_postream)
	{
		*m_postream << obj.c_str();
	}
	return *this;
}

////{{ADD_HEAD,12/15/2006,R
////////////////////////////////////////////////////////////////////////////////
//#	std::endlo
/// @brief	std::endlo
/// @param[in]	obj		std::endlɂĂĂ
/// @retval	Q
/// @note	std::endl΍
/// @author	R
/// @date	2006/12/15
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator<<(std::ostream& (__cdecl * _f)(std::ostream&))
{
	if(m_postream)
	{
		(*_f)(*m_postream); return *this;
	}
	return *this;
}
////}}ADD_TAIL,12/15/2006,R

//istream ǂݍݗp
////////////////////////////////////////////////////////////////////////////////
//#	Pǂݍ
/// @brief	Pǂݍ
/// @param[out]	obj		unsigned char 󂯎
/// @retval	Q
/// @note	istreamPǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(unsigned char &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	Pǂݍ
/// @brief	Pǂݍ
/// @param[out]	obj		char 󂯎
/// @retval	Q
/// @note	istreamPǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(char &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	Pǂݍ
/// @brief	Pǂݍ
/// @param[out]	obj		signed char 󂯎
/// @retval	Q
/// @note	istreamPǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(signed char &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		short 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(short &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		unsigned short 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(unsigned short &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		int 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(int &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		unsigned int 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(unsigned int &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		long 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(long &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		unsigned long 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(unsigned long &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		double 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(double &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		long double 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(long double &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	lǂݍ
/// @brief	lǂݍ
/// @param[out]	obj		float 󂯎
/// @retval	Q
/// @note	istream琔lǂݍ
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
CCrypFile& CCrypFile::operator>>(float &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
CCrypFile& CCrypFile::operator>>(std::string &obj)
{
	if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
CCrypFile& CCrypFile::operator>>(std::istream& (__cdecl * _f)(std::istream&))
{
	if(m_pistream)
	{
		(*_f)(*m_pistream); return *this;
	}
	return *this;
}
CCrypFile& CCrypFile::operator>>(std::ios& (__cdecl * _f)(std::ios&))
{
	if(m_pistream)
	{
		(*_f)(*m_pistream); return *this;
	}
	return *this;
}
CCrypFile& CCrypFile::operator>>(std::streambuf* obj)
{
if(m_pistream)
	{
		*m_pistream >> obj;
	}
	return *this;
}
////////////////////////////////////////////////////////////////////////////////
//#	istreamsǂݍ
/// @brief	istreamsǂݍ
/// @param[out]	pch		󂯎|C^
/// @param[in]	nCount	pch̃TCY
/// @param[in]	delim	؂蕶
/// @retval	TRUE:	FALSE:sorI[
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::getline(char *pch, int nCount, char delim)
{
	if(m_pistream)
	{
		return m_pistream->getline(pch, nCount, delim) == NULL ? FALSE : TRUE;
	}
	return FALSE;
}
////////////////////////////////////////////////////////////////////////////////
//#	istreamsǂݍ
/// @brief	istreamsǂݍ
/// @param[out]	pch		󂯎|C^
/// @param[in]	nCount	pch̃TCY
/// @param[in]	delim	؂蕶
/// @retval	TRUE:	FALSE:sorI[
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::getline(std::string &obj)
{
	if(m_pistream)
	{
		return std::getline(*m_pistream, obj) == NULL ? FALSE : TRUE;
	}
	return FALSE;
}

////{{ADD_HEAD,12/15/2006,R
////////////////////////////////////////////////////////////////////////////////
//#	istreamꕶǂݍ
/// @retval	:ǂݍ񂾕 s:0
/// @author	R
/// @date	2006/12/15
////////////////////////////////////////////////////////////////////////////////
int CCrypFile::get(void)
{
	if(m_pistream)
	{
		return m_pistream->get();
	}
	return 0;
}
////}}ADD_TAIL,12/15/2006,R


////////////////////////////////////////////////////////////////////////////////
//#	istreamsǂݍ
/// @brief	istreamsǂݍ
/// @param[out]	pch		󂯎|C^
/// @param[in]	nCount	pch̃TCY
/// @param[in]	delim	؂蕶
/// @retval	TRUE:	FALSE:sorI[
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::fgets(char *pch, int nCount, char delim)
{
	if(m_pistream)
	{
		return m_pistream->getline(pch, nCount, delim) == NULL ? FALSE : TRUE;
	}
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
//#	񏑂o
/// @brief	񏑂o
/// @param[in]	pch		oւ̃|C^
/// @retval	0:s or ̐
/// @note	ostreamɕo
/// @author	R
/// @date	2006/12/01
////////////////////////////////////////////////////////////////////////////////
int CCrypFile::fputs(const char *pch)
{
	if(m_postream)
	{
		*m_postream << pch;
		return _tcslen(pch);
	}
	return 0;
}

////////////////////////////////////////////////////////////////////////////////
//#	_\鎞̐xݒ肷
/// @brief	_\鎞̐xݒ肷
/// @param[in]	streamsize		xw
/// @retval	0:s or x
/// @note	precisionĂяo
/// @author	R
/// @date	2006/12/04
////////////////////////////////////////////////////////////////////////////////
int CCrypFile::precision(int streamsize)
{
	if(m_postream)
	{
		return m_postream->precision(streamsize);
	}
	return 0;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@CI[vmFp
/// @brief	t@CI[vmFp
/// @param[in]	mFtO FALSE:JĂFALSE	TRUE:JĂȂƂFALSE
/// @note	t@CJmF
/// @author	R
/// @date	2006/12/04
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::operator ==(BOOL obj) const
{
	if(!obj)
	{
		if(!m_hFile) return TRUE;
		if(m_pistream)
		{
			if(m_pistream->eof()) return TRUE;
		}
		if(m_postream)
		{
			if(m_postream->eof()) return TRUE;
		}
		return FALSE;
	}
	else
	{
		if(!m_hFile) return FALSE;
		if(m_pistream)
		{
			if(m_pistream->eof()) return FALSE;
		}
		if(m_postream)
		{
			if(m_postream->eof()) return FALSE;
		}
		return TRUE;
	}
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
//#	t@CI[vmFp
/// @brief	t@CI[vmFp
/// @retval	TRUE:JĂ	FALSE:JĂȂ
/// @note	t@CJmF
/// @author	R
/// @date	2006/12/04
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::operator!() const
{
	if(!m_hFile) return TRUE;
	if(m_pistream)
	{
		if(m_pistream->eof()) return TRUE;
	}
	if(m_postream)
	{
		if(m_postream->eof()) return TRUE;
	}
	return FALSE;
}

////{{ADD_HEAD,12/14/2006,R
////////////////////////////////////////////////////////////////////////////////
//#	t@CI[vmFp
/// @brief	t@CI[vmFp
/// @retval	this:JĂ	NULL:JĂȂ
/// @note	t@CJmF
/// @note	while(CCrypFile >> obj)̂悤ȓǂݍݑΉ
/// @author	R
/// @date	2006/12/14
////////////////////////////////////////////////////////////////////////////////
CCrypFile::operator void *() const
{
	if(!m_hFile) return NULL;
	if(m_pistream)
	{
		if(m_pistream->eof()) return NULL;
	}
	if(m_postream)
	{
		if(m_postream->eof()) return NULL;
	}
	return (void *)this;
}

////////////////////////////////////////////////////////////////////////////////
//#	 nCount ɂȂ܂ŁAoj܂
/// @brief	 nCount ɂȂ܂ŁAoj܂
/// @retval	g̎Q
/// @note	istreamignoreĂяo
/// @author	R
/// @date	2006/12/14
////////////////////////////////////////////////////////////////////////////////
CCrypFile &CCrypFile::ignore(int nCount, int delim)
{
	if(m_pistream)
	{
		m_pistream->ignore(nCount, delim);
	}
	return *this;
}

////////////////////////////////////////////////////////////////////////////////
//#	istreamstreambufւ̃|C^擾
/// @brief	istreamstreambufւ̃|C^擾
/// @retval	streambufւ̃|C^
/// @note	istreamstreambufĂяo
/// @author	R
/// @date	2006/12/14
////////////////////////////////////////////////////////////////////////////////
std::streambuf *CCrypFile::rdbuf() const
{
	if(m_pistream)
	{
		return m_pistream->rdbuf();
	}
	return NULL;
}

////////////////////////////////////////////////////////////////////////////////
//#	istream̏Ԃeofbitׂ
/// @brief	istream̏Ԃeofbitׂ
/// @retval	eofbit:true	̑:false
/// @note	eofbv֐
/// @author	R
/// @date	2006/12/14
////////////////////////////////////////////////////////////////////////////////
bool CCrypFile::eof() const
{
	if(m_pistream)
	{
		return m_pistream->eof();
	}
	if(m_postream)
	{
		return m_postream->eof();
	}
	return false;
}
////}}ADD_TAIL,12/14/2006,R
////{{ADD_HEAD,12/15/2006,R
////////////////////////////////////////////////////////////////////////////////
//#	istream̏Ԃfailbitׂ
/// @brief	istream̏Ԃfailbitׂ
/// @retval	failbit:true	̑:false
/// @note	failbv֐
/// @author	R
/// @date	2006/12/15
////////////////////////////////////////////////////////////////////////////////
bool CCrypFile::fail(void)
{
	if(m_pistream)
	{
		return m_pistream->fail();
	}
	if(m_postream)
	{
		return m_postream->fail();
	}
	return true;
}

////////////////////////////////////////////////////////////////////////////////
//#	istream̏Ԃbadbitׂ
/// @brief	istream̏Ԃbadbitׂ
/// @retval	badbit:true	̑:false
/// @note	badbv֐
/// @author	R
/// @date	2006/12/15
////////////////////////////////////////////////////////////////////////////////
bool CCrypFile::bad(void)
{
	if(m_pistream)
	{
		return m_pistream->bad();
	}
	if(m_postream)
	{
		return m_postream->bad();
	}
	return true;
}

////}}ADD_TAIL,12/15/2006,R

////////////////////////////////////////////////////////////////////////////////
//#	wobt@̉sR[h𓝈
/// @brief	wobt@̉sR[h𓝈
/// @param[in,out]	buf	ϊobt@
/// @retval	TRUE:ϊI	FALSE:ϊobt@
/// @note	"\r\n"'\n'ɂ邽߂'\r'폜
/// @author	R
/// @date	2006/12/19
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::CodeUnionConversion(std::vector<BYTE> &buf)
{
	if(buf.empty())
	{//f[^
		return FALSE;
	}

	DWORD size = buf.size();
	std::vector<BYTE>::iterator it = buf.begin();
	while(it != buf.end())
	{
		UINT un = mbs2mbc(it);
		if(un < 256)
		{
			if(*it == (BYTE)'\r')
			{//sR[h'\r'T
				if(*(it+1) == (BYTE)'\n')
				{//'\n'ȂsR[h
					it = buf.erase(it);
				}
			}
			it++;
		}
		else
		{//SpȂv...Ȃ͂iOOG
			it += 2;
		}
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	sR[hWindowspɕϊ
/// @brief	sR[hWindowspɕϊ
/// @param[in,out]	buf	ϊobt@
/// @retval	TRUE:ϊI	FALSE:ϊobt@
/// @note	'\n'"\r\n"ɕϊiȂǂł'\n'݂̂ł͉sƂ݂ȂȂ...j
/// @author	R
/// @date	2006/12/20
////////////////////////////////////////////////////////////////////////////////
BOOL CCrypFile::CodeUnionReturn(std::vector<BYTE> &buf)
{
	if(buf.empty())
	{//f[^
		return FALSE;
	}

	DWORD size = buf.size();
	std::vector<BYTE>::iterator it = buf.begin();
	while(it != buf.end())
	{
		UINT un = mbs2mbc(it);
		if(un < 256)
		{
			if(*it == (BYTE)'\n')
			{//^[R[hǉ
				if(it != buf.begin())
				{
					if(*(it-1) != (BYTE)'\r')
					{
						it = buf.insert(it, '\r');
					}
				}
				else
				{
					it = buf.insert(it, '\r');
				}
				//ǉ
//				it++;
			}
			it++;
		}
		else
		{//SpȂv...Ȃ͂iOOG
			it += 2;
		}
	}

	while(TRUE)
	{
		it = buf.end();
		it--;
		if(*it == '\0')
		{//I[\0j?
			m_buf.pop_back();
		}
		else break;
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//#	wobt@UINTɕϊ
/// @brief	wobt@UINTɕϊ
/// @param[buf]	buf	ϊobt@
/// @retval	256菬:p	256傫:Sp
/// @note	wobt@̕Sppʂ邽߂Ɏgp
/// @author	R
/// @date	2006/12/20
////////////////////////////////////////////////////////////////////////////////
UINT CCrypFile::mbs2mbc(BYTE *buf)
{
	UINT uChar;
	if(_ismbslead(LPBYTE(buf),LPBYTE(buf))) {
		uChar = (WORD)(*((LPBYTE)buf)) << 8;
		uChar |= *(((LPBYTE)buf)+1);
	} else {
		uChar = (BYTE)*buf;
	}
	return uChar;
}

//ړpXiwpXɂꍇɈړj
BOOL CCrypFile::SetOriginPath(const PCSTR path)
{
	if(m_pRedirectingPath)
	{
		return m_pRedirectingPath->SetOriginPath(path);
	}
	return FALSE;
}
BOOL CCrypFile::SetOriginPath(const PCWSTR path)
{
	if(m_pRedirectingPath)
	{
		return m_pRedirectingPath->SetOriginPath(path);
	}
	return FALSE;
}
//ړpXiړpXɂꍇɈړꏊj
BOOL CCrypFile::SetMovePath(const PCSTR path)
{
	if(m_pRedirectingPath)
	{
		return m_pRedirectingPath->SetMovePath(path);
	}
	return FALSE;
}
BOOL CCrypFile::SetMovePath(const PCWSTR path)
{
	if(m_pRedirectingPath)
	{
		return m_pRedirectingPath->SetMovePath(path);
	}
	return FALSE;
}
//} // end namespace
