
#include "FileOpen.h"

CFileOpen::CFileOpen():m_hFile(NULL),m_dwAccess(0),m_dwFileSize(0),m_dwHighFileSize(0)
{
}
CFileOpen::CFileOpen(const _TCHAR *pFileName, DWORD dwAccess):m_hFile(NULL),m_dwAccess(0),m_dwFileSize(0),m_dwHighFileSize(0)
{
	//t@CJ
	Open(pFileName, dwAccess);
}

CFileOpen::~CFileOpen()
{
	CFileOpen::Close();
}

//ǂݍݐpŊJ
DWORD CFileOpen::LoadOpen(const _TCHAR *pFileName)
{
	m_csFileName = pFileName;
	//t@CJ
	m_hFile = ::CreateFile(pFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	if(m_hFile == INVALID_HANDLE_VALUE)
	{//I[vG[
		m_hFile = NULL;
		return -1;
	}
	//擪ɃZbgĂ
	::SetFilePointer(m_hFile, 0, NULL, FILE_BEGIN);

	//t@C̃TCY擾
	m_dwFileSize = ::GetFileSize(m_hFile, &m_dwHighFileSize);

	return m_dwFileSize;
}
//opŊJ
DWORD CFileOpen::SaveOpen(const _TCHAR *pFileName)
{
	m_csFileName = pFileName;
	//t@CJ
	m_hFile = ::CreateFile(pFileName, GENERIC_WRITE, 0, NULL, 
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

	//t@CJȂ
	if(m_hFile == INVALID_HANDLE_VALUE){
		m_hFile = NULL;
		return -1;
	}
	
	m_dwFileSize = 0;
	m_dwHighFileSize = 0;

	return 0;
}
//ǂݏpŊJ
DWORD CFileOpen::CombinationOpen(const _TCHAR *pFileName)
{
	m_csFileName = pFileName;
	//t@CJ
	m_hFile = ::CreateFile(pFileName, GENERIC_READ | GENERIC_WRITE, 0, NULL, 
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH, NULL);

	//t@CJȂ
	if(m_hFile == INVALID_HANDLE_VALUE){
		m_hFile = NULL;
		return -1;
	}
	
	//擪ɃZbgĂ
	::SetFilePointer(m_hFile, 0, NULL, FILE_BEGIN);

	//t@C̃TCY擾
	m_dwFileSize = ::GetFileSize(m_hFile, &m_dwHighFileSize);

	return m_dwFileSize;
}

//t@CJ
DWORD CFileOpen::Open(const _TCHAR *pFileName, DWORD dwAccess)
{
	//t@C
	Close();
	//I[vtOێ
	m_dwAccess = dwAccess;

	//tO킯
	switch(dwAccess)
	{
	case READ_OPEN:
		return LoadOpen(pFileName);
		break;
	case WRITE_OPEN:
		return SaveOpen(pFileName);
		break;
	case COMBINATION_OPEN:
		return CombinationOpen(pFileName);
		break;
	}
	//wG[
	return -1;
}
//t@Cǂݍ
DWORD CFileOpen::ReadFile(LPVOID pBuf, DWORD size)
{
	if(!m_hFile)
	{//t@CJĂȂ
		return 0;
	}
	DWORD ReadSize = 0;
	if(!::ReadFile(m_hFile, pBuf, size, &ReadSize, NULL))
	{
		DWORD error = ::GetLastError();
	}
	return ReadSize;
}
//t@Cɏo
DWORD CFileOpen::WriteFile(LPVOID pBuf, DWORD size)
{
	if(!m_hFile)
	{//t@CJĂȂ
		return 0;
	}
	DWORD WriteSize = 0;
	if(!::WriteFile(m_hFile, pBuf, size, &WriteSize, NULL))
	{
		DWORD error = ::GetLastError();
	}
	return WriteSize;
}
//t@CTCY擾
DWORD CFileOpen::GetFileSize(DWORD *High)
{
	if(!m_hFile)
	{//t@CJĂȂ
		if(High) *High = 0;
		return 0;
	}
	return ::GetFileSize(m_hFile, High);
}
//t@C|C^̈ړ
DWORD CFileOpen::SetFilePointer(LONG Move, LONG *MoveHigh, DWORD MoveMethod)
{
	if(!m_hFile)
	{//t@CJĂȂ
		return 0;
	}
	return ::SetFilePointer(m_hFile, Move, MoveHigh, MoveMethod);
}

//t@C
BOOL CFileOpen::Close(void)
{
	//f[^̏
	m_dwAccess = 0;
	m_dwFileSize = 0;
	m_dwHighFileSize = 0;

	if(!m_hFile)
	{//JĂȂ
		return FALSE;
	}
	BOOL ret = ::CloseHandle(m_hFile);
	if(!ret)
	{//G[擾
		DWORD error = ::GetLastError();
	}
	m_hFile = NULL;
	m_csFileName = _T("");
	return ret;
}

//t@C𕡍ēǂݍ
DWORD CFileOpen::ReadCrypFile(LPVOID pBuf, DWORD size, BOOL bCryp, const _TCHAR *szKey)
{
	if(!bCryp || !szKey)
	{//Ȃ
		return ReadFile(pBuf, size);
	}

	DWORD i;
	//pL[̍쐬
	DWORD dwKey = 0;
	for(i = 0; i < _tcslen(szKey); i++)
	{
		dwKey += szKey[i];
	}
	BYTE byXOR = (BYTE)( dwKey % 0xFF );
	BYTE byShift = (BYTE)( byXOR % 6 ) + 1;

	//t@Cǂݍ
	DWORD ret = ReadFile(pBuf, size);
	if(ret != size)
	{//ǂݍݎs
		return ret;
	}

	//
	BYTE *pReadPrt = (BYTE *)pBuf;
	for(i = 0; i < ret; i++)
	{
		pReadPrt[i] = pReadPrt[i] << byShift | (pReadPrt[i] >> (8 - byShift));
		pReadPrt[i] ^= byXOR;
	}
	return ret;
}

//t@CÍďo
DWORD CFileOpen::WriteCrypFile(LPVOID pBuf, DWORD size, BOOL bCryp, const _TCHAR *szKey)
{
	if(!bCryp || !szKey)
	{//ÍȂ
		return WriteFile(pBuf, size);
	}

	DWORD i;
	//pL[̍쐬
	DWORD dwKey = 0;
	for(i = 0; i < _tcslen(szKey); i++)
	{
		dwKey += szKey[i];
	}
	BYTE byXOR = (BYTE)( dwKey % 0xFF );
	BYTE byShift = (BYTE)( byXOR % 6 ) + 1;

	BYTE *pWritePrt = (BYTE *)pBuf;
	BYTE *pWriteBuf = new BYTE[size];
	
	//Í
	for(i = 0; i < size; i++)
	{
		pWriteBuf[i] = pWritePrt[i] ^ byXOR;
		pWriteBuf[i] = (pWriteBuf[i] >> byShift) | (pWriteBuf[i] << (8 - byShift));
	}

	//o
	DWORD ret = WriteFile(pWriteBuf, size);
	delete [] pWriteBuf;

	return ret;
}
