
#include "RedirectingPathW.h"

#include <io.h>	// _tacess

#include <shlobj.h>
#pragma comment(lib, "shell32.lib")

#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")

#define _PROGRAM_FILES_		(0)	//!< ProgramFilesw
#define _NO_PROGRAM_FILES_	(1)	//!< programfilesł͂Ȃ
#define _FULL_PATH_ERROR_	(2)	//!< tpXϊs
#define _COMPARE_STRING_ERROR_	(3)	//!< rs

CRedirectingPathW::CRedirectingPathW()
{
	InitFilePath();
}

CRedirectingPathW::~CRedirectingPathW()
{
}

//t@CpX̎擾
BOOL CRedirectingPathW::InitFilePath(void)
{
	m_ProgramFiles = L"";
	m_LocalAppData = L"";

	WCHAR szPath[_MAX_PATH];
	LPITEMIDLIST pidl;

//	WCHAR szLocalPath[_MAX_PATH];

	IMalloc *pMalloc;
    SHGetMalloc( &pMalloc );

	//ProgramFiles̎擾
	if(SUCCEEDED(::SHGetSpecialFolderLocation(NULL,CSIDL_PROGRAM_FILES,&pidl)))
	{
		::SHGetPathFromIDListW(pidl,szPath); // pXɕϊ
        pMalloc->Free(pidl);

		//obNXbV̒ǉ
		PathAddBackslashW(szPath);
		m_ProgramFiles = szPath;
	}
	/*
	//NCAgpXɕύX
	if(GetCurrentPath(szPath))
	{
		m_ProgramFiles = szPath;
	}*/

	//AppData̎擾
	if(SUCCEEDED(::SHGetSpecialFolderLocation(NULL,CSIDL_COMMON_APPDATA,&pidl)))
//	if(::SHGetSpecialFolderPathW(NULL, szPath, CSIDL_COMMON_DOCUMENTS, FALSE))
	{
		::SHGetPathFromIDListW(pidl,szPath); // pXɕϊ
        pMalloc->Free(pidl);

		//擾pX烋[ghCu擾
//		PathBuildRootW(szPath, PathGetDriveNumberW(szPath));
		//ۑpX쐬
//		PathCombineW(szLocalPath, szPath, L"HMSCData");

		//obNXbV̒ǉ
		PathAddBackslashW(szPath);

		//쐬pXێ
		m_LocalAppData = szPath;

		//HMSC
//		m_LocalAppData += L"HMSC\\";
	}

	pMalloc->Release();

	//擾s
	if(m_ProgramFiles.empty() || m_LocalAppData.empty())
	{
		return FALSE;
	}
	return TRUE;
}

//ۑtH_pX̎w
BOOL CRedirectingPathW::SetLocalFolder(const PCWSTR folder)
{
	//LocalAppDatapXݒ肳ĂȂƂFALSEԂ
	BOOL ret = m_LocalAppData.empty() == FALSE ? TRUE : FALSE;
	m_LocalAppData = folder;
	return FALSE;
}

//wpXtpXɕϊ
BOOL CRedirectingPathW::GetFullPath(const PCWSTR path, std::wstring &fullpath)
{
	WCHAR str[_MAX_PATH];
	if(_wfullpath(&str[0], path, _MAX_PATH) == NULL)
	{//擾s
		return FALSE;
	}
	fullpath = str;
	return TRUE;
}

//ProgramFilesȉ
DWORD CRedirectingPathW::ProgramFilesCheck(const PCWSTR path, std::wstring &str)
{
	str = path;

	if(wcslen(path) < wcslen(m_ProgramFiles.c_str()))
	{//ProgramFilesȂꍇ͌ȂĂvH
		return _NO_PROGRAM_FILES_;
	}
/*
	if(lstrcmpiW(path, m_ProgramFiles.c_str()) != 0)
	{//ProgramFilesȉł͂Ȃ
		return _NO_PROGRAM_FILES_;
	}
*/
	//̒𓯂ɂ
	std::wstring wPath;
	wPath = path;
	wPath.erase(wcslen(m_ProgramFiles.c_str()));
	int ret = CompareStringW(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
		wPath.c_str(), -1, m_ProgramFiles.c_str(), -1);
	if(ret == 0)
	{//rs
		return _COMPARE_STRING_ERROR_;
	}
	else if(ret != CSTR_EQUAL)
	{//ProgramFilesȉł͂Ȃ
		return _NO_PROGRAM_FILES_;
	}

	//wpXɕϊ...?
	str.erase(0, wcslen(m_ProgramFiles.c_str()));
	std::wstring tmp;
	tmp = m_LocalAppData;
//	tmp += L'\\';
	tmp += str;
	str.swap(tmp);

	return _PROGRAM_FILES_;
}

//wpXLocalpXɕϊ
BOOL CRedirectingPathW::GetLocalPath(const PCWSTR path, std::wstring &str)
{
	switch(ProgramFilesCheck(path, str))
	{
	case _FULL_PATH_ERROR_:	// pX擾G[
		return FALSE;
		break;
	case _COMPARE_STRING_ERROR_:	// rs
		return FALSE;
		break;
	case _PROGRAM_FILES_:	// vOt@Cȉ
		break;
	case _NO_PROGRAM_FILES_:	// vOt@Cȉł͂Ȃ
		break;
	}
	return TRUE;
}

//wt@C̃Rs[
BOOL CRedirectingPathW::Copy(const PCWSTR lpszExistingFile, const PCWSTR lpszNewFile)
{
	//wtH_̍쐬
	WCHAR drive[_MAX_DRIVE] , dir[_MAX_DIR] , fname[_MAX_FNAME] , ext[_MAX_EXT];
	::_wsplitpath(lpszNewFile, drive, dir, fname, ext);
	std::wstring folder;
	folder = drive;
	folder += dir;
	//tH_쐬
	int ret = SHCreateDirectoryExW(NULL, folder.c_str(), NULL);
	switch(ret)
	{
	case ERROR_SUCCESS:	//쐬
	case ERROR_FILE_EXISTS:	//݂Ă
	case ERROR_ALREADY_EXISTS:	//݂Ă
		break;
	default:
		return FALSE;
		break;
	}

	if(_waccess(lpszExistingFile, 0) != 0)
	{//t@C݂ĂȂ
		return TRUE;
	}

	//t@C̃Rs[(Rs[Ƀf[^ꍇ͏㏑Ȃ)
	return ::CopyFileW(lpszExistingFile, lpszNewFile, TRUE);
}

//t@CpX̎擾
const PCWSTR CRedirectingPathW::GetReadFilePath(const PCWSTR path)
{
	//wpXtpXɕϊ
	std::wstring fullpath;
	if(!GetFullPath(path, fullpath))
	{//ϊs
		return NULL;
	}

	if(!GetLocalPath(fullpath.c_str(), m_Path))
	{//pX̎擾s
		return NULL;
	}
	//t@C̑݊mF
	if(_waccess(m_Path.c_str(), 0) != 0)
	{//t@C݂ĂȂ
		m_Path = fullpath;
	}

	return m_Path.c_str();
}

const PCWSTR CRedirectingPathW::GetWriteFilePath(const PCWSTR path)
{
	//wpXtpXɕϊ
	std::wstring fullpath;
	if(!GetFullPath(path, fullpath))
	{//ϊs
		return NULL;
	}

	if(!GetLocalPath(fullpath.c_str(), m_Path))
	{//pX̎擾s
		return NULL;
	}
	//t@C̑݊mF
	if(_waccess(m_Path.c_str(), 0) != 0)
	{//݂ĂȂꍇ͌̈ʒuɂt@CRs[Ă
		//t@C̃Rs[
		Copy(fullpath.c_str(), m_Path.c_str());
	}
	return m_Path.c_str();
}

//ppX̎擾
const PCWSTR CRedirectingPathW::GetFindFilePath(const PCWSTR path)
{
	//wpXtpXɕϊ
	std::wstring fullpath;
	if(!GetFullPath(path, fullpath))
	{//ϊs
		return NULL;
	}

	if(!GetLocalPath(fullpath.c_str(), m_Path))
	{//pX̎擾s
		return NULL;
	}

	return m_Path.c_str();
}

void CRedirectingPathW::Delete(void)
{
	delete this;
}

//ړpXiwpXɂꍇɈړj
BOOL CRedirectingPathW::SetOriginPath(const PCWSTR path)
{
	std::wstring fullpath;
	if(!GetFullPath(path, fullpath))
	{//擾s
		return FALSE;
	}
	
	WCHAR szPath[_MAX_PATH];
	wcscpy(szPath, fullpath.c_str());
	//obNXbV̒ǉ
	PathAddBackslashW(szPath);
	//pX̕ێ
	m_ProgramFiles = szPath;
	return TRUE;
}

//ړpXiړpXɂꍇɈړꏊj
BOOL CRedirectingPathW::SetMovePath(const PCWSTR path)
{
	std::wstring fullpath;
	if(!GetFullPath(path, fullpath))
	{//擾s
		return FALSE;
	}
	
	WCHAR szPath[_MAX_PATH];
	wcscpy(szPath, fullpath.c_str());
	//obNXbV̒ǉ
	PathAddBackslashW(szPath);
	//pX̕ێ
	m_LocalAppData = szPath;
	return TRUE;
}

BOOL CRedirectingPathW::GetCurrentPath(WCHAR *path)
{
	WCHAR csPath[_MAX_PATH];
	WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR];
	::GetModuleFileNameW(NULL, csPath, sizeof(csPath));
	_wsplitpath(csPath, drive, dir, NULL, NULL);
	wcscpy(path, drive);
	wcscat(path, dir);
	PathAddBackslashW(path);
	return TRUE;
}


