
#include "CustomBrowseForFolder.h"

#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")
#include <winnetwk.h>
#pragma comment(lib, "mpr.lib")


const char CustomBrowseForFolderDlgStr[] = "MyCustomBrowseForFolderDlgStr";
HWND CCustomSHBrowseForFolder::m_hWnd = NULL;

CCustomSHBrowseForFolder::CCustomSHBrowseForFolder():m_bCustomFlag(0),m_bNetwork(TRUE),m_bEnablePath(TRUE)
{
	//0Zbg
	ZeroMemory(&m_bi, sizeof(BROWSEINFO));
	
	//ꉞ
	m_csTitle.Empty();				//!< _CAO^Cg
	m_csOKBtn.Empty();				//!< OK{^x
	m_csCancelBtn.Empty();			//!< Cancel{^x
	m_csDefaultPath.Empty();		//!< ftHgpX
	m_csSelectPath.Empty();			//!< IpX

	m_RootFolderID = CSIDL_DESKTOP;
}
CCustomSHBrowseForFolder::~CCustomSHBrowseForFolder()
{
}

//tH_wR[obN
int CALLBACK CCustomSHBrowseForFolder::CustomBrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lp, LPARAM pData)
{
	CCustomSHBrowseForFolder *pDlg = (CCustomSHBrowseForFolder *)GetProp(m_hWnd, CustomBrowseForFolderDlgStr);
	if(pDlg == NULL){
		DestroyWindow(hwnd);
		return 0L;
	}
	return pDlg->CustomBrowseProc(hwnd, uMsg, lp, pData);
}

//tH_wR[obN
int CCustomSHBrowseForFolder::CustomBrowseProc(HWND hwnd, UINT uMsg, LPARAM lp, LPARAM pData)
{
	HWND hOKWnd, hCancelWnd;
	_TCHAR szDir[MAX_PATH];
	switch (uMsg)
	{
	case BFFM_INITIALIZED:	//
		//LvV̕ύX
		hOKWnd		= ::GetDlgItem( hwnd, IDOK );
		hCancelWnd	= ::GetDlgItem( hwnd, IDCANCEL );
		if( !m_csTitle.IsEmpty() )
			::SetWindowText( hwnd, m_csTitle );
		if( hOKWnd != NULL && !m_csOKBtn.IsEmpty() )
			::SetWindowText( hOKWnd, m_csOKBtn );
		if( hCancelWnd && !m_csCancelBtn.IsEmpty() )
			::SetWindowText( hCancelWnd, m_csCancelBtn );

		//ftHgpX
		if(!m_csDefaultPath.IsEmpty())
		{
			::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)(LPCTSTR(m_csDefaultPath)));
		}
		break;
	case BFFM_SELCHANGED:	//I
		if(SHGetPathFromIDList((LPITEMIDLIST)lp, szDir))
		{
			if(!m_bNetwork)
			{//lbg[NhCu
				//szDirlbg[Nׂ
				if(CheckNetworkDrive(szDir))
				{//lbg[NhCu
					SendMessage(hwnd, BFFM_ENABLEOK, 0, 0);
				}
			}
			if(!m_bEnablePath)
			{//wpX
				if(CheckEnablePath(szDir))
				{
					SendMessage(hwnd, BFFM_ENABLEOK, 0, 0);
				}
			}
		}
		else
		{//ȃpXH
			SendMessage(hwnd, BFFM_ENABLEOK, 0, 0);
		}
		break;
	default:
		break;
	}
	return 0;
}

//EChEnhɃ|C^Zbg
BOOL CCustomSHBrowseForFolder::SetProc(HWND hWnd)
{
	return SetProp(hWnd, CustomBrowseForFolderDlgStr, (HANDLE)this);
}
//EChEnh|C^j
BOOL CCustomSHBrowseForFolder::ReleaseProc(HWND hWnd)
{
	if(hWnd)
	{
		RemoveProp(m_hWnd, CustomBrowseForFolderDlgStr);
	}
	return hWnd == NULL ? FALSE : TRUE;
}

//wpXlbg[NhCuׂ
BOOL CCustomSHBrowseForFolder::CheckNetworkDrive(const _TCHAR *pPath)
{
	_TCHAR *pBuf = new _TCHAR[_tcslen(pPath) + 1];
	ZeroMemory(pBuf, sizeof(_TCHAR) * (_tcslen(pPath) + 1));
	strcpy(pBuf, pPath);
	if(!PathStripToRoot(pBuf))
	{//hCu񂪂ȂHH
		delete [] pBuf;
		return FALSE;
	}

	delete [] pBuf;

	//hCu^[̂ݎ擾
	CString csPath = pPath;
	CString csBuf = csPath.Left(csPath.FindOneOf(_T("\\")));

	//lbg[Nׂ
	_TCHAR Remote[_MAX_PATH];
	DWORD size = _MAX_PATH;
	DWORD ret = WNetGetConnection(LPCTSTR(csBuf), Remote, &size);
	switch(ret)
	{
	case NO_ERROR:	//lbg[NhCu
		return TRUE;
	case ERROR_BAD_DEVICE:	//ȃhCu
	case ERROR_NOT_CONNECTED:
	case ERROR_MORE_DATA:
	case ERROR_CONNECTION_UNAVAIL:
	case ERROR_NO_NETWORK:
	case ERROR_EXTENDED_ERROR:
	case ERROR_NO_NET_OR_BAD_PATH:
	default:
		break;
	}

	return FALSE;
}

//wpXȉׂ
BOOL CCustomSHBrowseForFolder::CheckEnablePath(const _TCHAR *pPath)
{
	if(!pPath || _tcslen(pPath) == 0 || m_csEnablePath.IsEmpty())
	{
		return FALSE;
	}

	_TCHAR *szBuf = new _TCHAR[_tcslen(pPath) + 2];
	ZeroMemory(szBuf, sizeof(_TCHAR) * (_tcslen(pPath) + 2));
	strcpy(szBuf, pPath);
	PathAddBackslash(szBuf);

	if(_tcslen(szBuf) < _tcslen(LPCTSTR(m_csEnablePath)))
	{
		delete [] szBuf;
		return FALSE;
	}

	CString cPath;
	cPath = szBuf;
	cPath = cPath.Left(_tcslen(LPCTSTR(m_csEnablePath)));
	if(CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
		LPCTSTR(cPath), -1, LPCTSTR(m_csEnablePath), -1) == CSTR_EQUAL)
	{//wpXɂ
		delete [] szBuf;
		return TRUE;
	}

	delete [] szBuf;
	return FALSE;
}

//LvṼZbg
/// @param[in]	pTitle		_CAO^Cg
/// @param[in]	pOKBtn		OK{^LvV
/// @param[in]	pCancelBtn	Cancel{^LvV
void CCustomSHBrowseForFolder::SetCaption(const _TCHAR *pBrowseTitle, const _TCHAR *pTitle, const _TCHAR *pOKBtn, const _TCHAR *pCancelBtn)
{
	if(!pBrowseTitle)
	{
		m_csBrowseTitle.Empty();
	}
	else
	{
		m_csBrowseTitle = pBrowseTitle;
	}
	if(!pTitle)
	{
		m_csTitle.Empty();
	}
	else
	{
		m_csTitle = pTitle;
	}

	if(!pOKBtn)
	{
		m_csOKBtn.Empty();
	}
	else
	{
		m_csOKBtn = pOKBtn;
	}

	if(!pCancelBtn)
	{
		m_csCancelBtn.Empty();
	}
	else
	{
		m_csCancelBtn = pCancelBtn;
	}
}

//f[^Zbg
/// @param[in]	hWnd			eEChE
/// @param[in]	bCustomFlag		JX^ptO
/// @param[in]	pDefaultPath	tH_
void CCustomSHBrowseForFolder::SetDefaultPath(HWND hWnd, BOOL bCustomFlag, const _TCHAR *pDefaultPath)
{
	m_hWnd = hWnd;
	m_bCustomFlag = bCustomFlag;
	if(!pDefaultPath)
	{
		m_csDefaultPath.IsEmpty();
	}
	else
	{
		m_csDefaultPath = pDefaultPath;
	}
}

//[gtH_IDZbg
/// 萔 l e 
/// CSIDL_DESKTOP &H0 fXNgbv 
/// CSIDL_PROGRAMS &H2 X^[gj[́uvOv 
/// CSIDL_CONTROLS &H3 Rg[pl 
/// CSIDL_PRINTERS &H4 v^ 
/// CSIDL_PERSONAL &H5 p[\i 
/// CSIDL_FAVORITES &H6 uCɓvtH_ 
/// CSIDL_STARTUP &H7 uX^[gAbvvtH_ 
/// CSIDL_RECENT &H8 X^[gj[́uŋߎgt@Cv 
/// CSIDL_SENDTO &H9  
/// CSIDL_BITBUCKET &HA ݔ 
/// CSIDL_STARTMENU &HB X^[gj[ 
/// CSIDL_DESKTOPDIRECTORY &H10 fXNgbv 
/// CSIDL_DRIVES &H11 }CRs[^ 
/// CSIDL_NETWORK &H12 lbg[NRs[^ 
/// CSIDL_NETHOO &H13 @ 
/// CSIDL_FONTS &H14 tHg 
/// CSIDL_TEMPLATES &H15 Shell New 
void CCustomSHBrowseForFolder::SetRootFolderID(int ID)
{
	m_RootFolderID = ID;
}

//lbg[NhCu𖳌ɂ邩H
/// @param bFlag FALSE/ TRUE/L
/// }Clbg[N͖ɂȂȂƂɒ
void CCustomSHBrowseForFolder::SetNetworkFlag(BOOL bFlag)
{
	m_bNetwork = bFlag;
}

//SHBrowseForFolders
/// @param[in]	hWnd			eEChEnh
/// @param[in]	bCustomFlag		JX^ptO
/// @param[in]	pDefaultPath	tH_
/// @param[in]	pTitle			_CAO^Cg
/// @param[in]	pOKBtn			OK{^̃LvV
/// @param[in]	pCancelBtn		Cancel{^̃LvV
///	@retbal	TRUE/I	FALSE/LZorG[
BOOL CCustomSHBrowseForFolder::DoModal(HWND hWnd, DWORD bCustomFlag, const _TCHAR *pDefaultPath,
	const _TCHAR *pBrowseTitle, const _TCHAR *pTitle, const _TCHAR *pOKBtn, const _TCHAR *pCancelBtn)
{
	//f[^Zbg
	SetDefaultPath(hWnd, bCustomFlag, pDefaultPath);
	SetCaption(pBrowseTitle, pTitle, pOKBtn, pCancelBtn);

	return DoModal();
}

///	@retbal	TRUE/I	FALSE/LZorG[
BOOL CCustomSHBrowseForFolder::DoModal(void)
{
	//IpX̏
	m_csSelectPath.Empty();

	if(!m_hWnd)
	{//EChEnhs
		return FALSE;
	}

	if(!SetProc(m_hWnd))
	{//|C^Zbgs
		return FALSE;
	}

	LPMALLOC lpMalloc;
	LPITEMIDLIST lpRootItemIDList;	//[gpX
	_TCHAR *lpBuf;	//obt@

	//Malloc
	if(!SUCCEEDED(SHGetMalloc(&lpMalloc)))
	{//s
		ReleaseProc(m_hWnd);
		return FALSE;
	}
	//擾
	lpBuf = (_TCHAR*)lpMalloc->Alloc(_MAX_PATH);
	if(!lpBuf)
	{
		ReleaseProc(m_hWnd);
		lpMalloc->Release();
		return FALSE;
	}
	//[gpX擾iƂ肠}CRs[^j
	if(!SUCCEEDED(SHGetSpecialFolderLocation(m_hWnd, m_RootFolderID/*CSIDL_DRIVES*/, &lpRootItemIDList)))
	{//pX擾s
		ReleaseProc(m_hWnd);
		lpMalloc->Free(lpBuf);
		lpMalloc->Release();
		return FALSE;
	}

	memset(&m_bi, 0, sizeof(m_bi));

	m_bi.hwndOwner = m_hWnd;
	m_bi.pidlRoot = lpRootItemIDList;
	m_bi.pszDisplayName = lpBuf;
	m_bi.lpszTitle = m_csBrowseTitle.IsEmpty() == FALSE ? LPCTSTR(m_csBrowseTitle) : NULL;
	m_bi.ulFlags = m_bCustomFlag == 0 ? BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE : m_bCustomFlag;
	m_bi.lpfn = CustomBrowseCallbackProc;
	m_bi.lParam = 0;

	m_csSelectPath.Empty();

	LPITEMIDLIST pidl;
	pidl = ::SHBrowseForFolder(&m_bi);
	if(pidl)
	{
		if(SHGetPathFromIDList(pidl, lpBuf))
		{
			m_csSelectPath = lpBuf;
//			lpMalloc->Free(pidl);
			::CoTaskMemFree(pidl);
		}
	}

	ReleaseProc(m_hWnd);
	lpMalloc->Free(lpBuf);
	lpMalloc->Release();

	return m_csSelectPath.IsEmpty() == FALSE ? TRUE : FALSE;
}

//IpX̎擾
CString CCustomSHBrowseForFolder::GetSelectPath(void)
{
	return m_csSelectPath;
}

//wpXȉIłȂ悤ɂ
BOOL CCustomSHBrowseForFolder::SetEnablePath(const _TCHAR *pPath)
{
	if(!pPath || _tcslen(pPath) == 0)
	{
		return FALSE;
	}
	m_bEnablePath = FALSE;
	m_csEnablePath = pPath;
	return FALSE;
}